package java.awt;
import java.awt.geom.*;
import java.io.*;

// This was written from memory. There may be severe errors.
public class Rectangle extends Rectangle2D implements Serializable {
    public int x;
    public int y;
    public int width;
    public int height;

    public Rectangle(int x, int y, int width, int height) {
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
    }

    public Rectangle intersection(Rectangle rect) {
	int iLeft   = Math.max(x,        rect.x);
	int iTop    = Math.max(y,        rect.y);
	int iRight  = Math.min(x+width,  rect.x+rect.width);
	int iBottom = Math.min(y+height, rect.y+rect.height);

	return new Rectangle(iLeft, iTop, iRight-iLeft, iBottom-iTop);
    }

    public Rectangle union(Rectangle rect) {
	int iLeft   = Math.min(x,        rect.x);
	int iTop    = Math.min(y,        rect.y);
	int iRight  = Math.max(x+width,  rect.x+rect.width);
	int iBottom = Math.max(y+height, rect.y+rect.height);

	return new Rectangle(iLeft, iTop, iRight-iLeft, iBottom-iTop);
    }

    public void translate(int xt, int yt) {
	x += xt;
	y += yt;
    }
    


    public boolean isEmpty() {
	return (width<=0) || (height<=0);
    }

    public boolean contains(int x, int y) {
	x -= this.x;
	y -= this.y;
	return 
	    (x>=0) && (x<width) &&
	    (y>=0) && (y<height);
    }

    public boolean contains(Rectangle r) {
	return (x<=r.x) || (y<=r.y) ||
	    ((x+width)>=(r.x+r.width)) || ((y+height)>=(r.y+r.height));
    }

    public String toString() {
	
	// string is modeled after X11 geomertry specifications
	return getClass().getName() + "["
	    + width + "x" + height + "+" + x + "+" + y +
	    "]";
    }

    public Rectangle getBounds () {
	return (Rectangle) clone();
    }

}
