package java.awt.image;

import java.util.Hashtable;

public interface ImageConsumer {

    // Hint flags:
    int RANDOMPIXELORDER  = 1<<0;
    int TOPDOWNLEFTRIGHT  = 1<<1;
    int COMPLETESCANLINES = 1<<2;
    int SINGLEPASS        = 1<<3;
    int SINGLEFRAME       = 1<<4;

    // Status codes:
    int IMAGEERROR      = 1;
    int SINGLEFRAMEDONE = 2;
    int STATICIMAGEDONE = 3;
    int IMAGEABORTED    = 4;

    void setDimensions(int width, int height);

    void setProperties(Hashtable props);

    void setColorModel(ColorModel model);

    void setHints(int hintFlags);

    void setPixels(int x, int y, int width, int height,
		   ColorModel model, byte[] pixels, int offset,
		   int scanlineStride);
    

    void setPixels(int x, int y, int width, int height,
		   ColorModel model, int[] pixels, int offset,
		   int scanlineStride);

    void imageComplete(int status);
}

	
