package no.rwr.x;
import java.awt.Rectangle;

public class Drawable extends XID {

    public Drawable(Display display, int xid) {
	super(display, xid);
    };

    public Rectangle copyIntoXImage(XImage dest, Rectangle bounds,
				     int destX, int destY) {
	
	Rectangle newBounds = null;
	int tries = 5;
	while (!bounds.isEmpty()) {
	    if (_copyIntoXImage(dest, bounds.x, bounds.y,
				bounds.width, bounds.height,
				destX, destY)) return bounds;
	    
	    // failed, likely due to wrong bounds...

	    newBounds = getBounds(newBounds);
	    
	    bounds = newBounds.intersection(bounds);
	    
	    tries--;
	    
	    if (tries < 0) {
		throw new RuntimeException("copyIntoXImage is buggy");
	    }
	    
	}

	return bounds; // always empty
    }



    /** Performs an XGetSubImage... */
    private native boolean _copyIntoXImage(XImage destinationImage,
					   int x, int y, int width, int height,
					   int destX, int destY);

    public native Rectangle getBounds(Rectangle rv);

    private static final String MSG_XGETSUBIMAGE_FAILED =
    "XGetSubImage() failed.";
    
}
