package no.rwr.x;
import gnu.gcj.RawData;
import java.awt.Rectangle;



/**
   There is no need to do coalescing of changes since Xlib will do
   this for us. The implementation now relies on the Xlib GC cache and
   will not try to be clever.  */
public class GC implements Cloneable {

    public GC(Drawable targetType) {
	this.targetType = targetType;
	initStructure(null);
    }

    public Object clone() {
	GC gcClone = (GC) super.clone();
	gcClone.structure = null;
	gcClone.initStructure(this);
	gcClone.updateClip();
	return gcClone;
    }

    private native void initStructure(GC copyFrom);

    public GC create() {
        return (GC) clone();
    }

    public void finalize() {
	disposeImpl();
    }

    public void dispose() {
	disposeImpl();
    }

    public synchronized native void disposeImpl();


    public native void setForeground(long pixel);
    public native void setFont(no.rwr.x.Font font);

    /** ... This is one of the few costly operations of this class.
	It might be beneficial to only set the clip if necessary. On
	the other hand, this can be done on a higher level. */
    public void setClipRectangles(Rectangle[] rectangles) {
	clip = new Clip(rectangles);
	updateClip();
    }


    public native void drawString(String text, int x, int y);
    public native void drawLine(int x1, int y1, int x2, int y2);
    public native void drawRectangle(int x, int y, int w, int h);


    public native void fillRectangle(int x, int y, int w, int h);
    public native void clearArea(int x, int y, int w, int h,
				 boolean exposures);



    public native void putImage(XImage image,
				int srcX, int srcY,
				int destX, int destY,
				int width, int height);

    public Drawable getDrawable() {
	return targetType;
    }

    private native void updateClip();

    

    private Drawable targetType;
    private RawData structure;
    private Clip clip;
}

