package no.rwr.xutil;

import no.rwr.x.*;
import no.rwr.xutil.event.*;

import java.util.*;

public class Frame extends TopLevelWindow {

    String title;
    String iconTitle;

    WMSizeHints normalSizeHints;

    public Frame() {
    }


    public void setGroupLeader(TopLevelWindow leader) {
	// ...
    }
    public void setTitle(String title) {
	this.title = title;

	checkTitle();
    }
    private void checkTitle() {
	if (!(valid && mapped)) return;
	if (title == null) return;

	//System.out.println("checkTitle, title="+title);
	no.rwr.x.Window win = getWindow();
	
	//System.out.println("checkTitle1, win="+win);
	win.setProperty("WM_NAME", "STRING", title);

	title = null;
	//System.out.println("checkTitle2");
    }
    
    public void setIconTitle(String iconTitle) {
	this.iconTitle = iconTitle;

	checkIconTitle();
    }

    private void checkIconTitle() {
	if (!(valid && mapped)) return;
	if (iconTitle == null) return;

	getWindow().setProperty("WM_ICON_NAME", "STRING", iconTitle);
	iconTitle = null;
    }
    

    public void whenMapped() {
	checkTitle();
	checkIconTitle();

	// Call super. Doing this, and doing this last, is very important.
	super.whenMapped();
    }

    public void processClientMessage(ClientMessageEvent message) {
	Display display = getWindow().getDisplay();
	int xa_WM_PROTOCOLS = display.getAtom("WM_PROTOCOLS");
	int xa_WM_DELETE_WINDOW = display.getAtom("WM_DELETE_WINDOW");
	if (message.getMessageTypeAtom() == xa_WM_PROTOCOLS) {
	    int protocolAtom = message.getInt(0);
	    if(protocolAtom == xa_WM_DELETE_WINDOW) {

		fireWindowCloseRequestEvent(message);
		
		return;
	    }
	    String protocol = display.getAtomName(protocolAtom);
	    System.err.println("Unknown WM protocol message: " + protocol);
	}

	System.err.println("Unknown client message: " + message);
	super.processClientMessage(message);
    }

    Vector windowCloseRequestListeners = new Vector(1);
    public void addWindowCloseRequestListener(WindowCloseRequestListener
					      wcrl) {
	windowCloseRequestListeners.addElement(wcrl);


	
	if (windowCloseRequestListeners.size() == 1) {
	    no.rwr.x.Window window = getWindow();
	    Display display = window.getDisplay();

	    int xa_WM_DELETE_WINDOW = display.getAtom("WM_DELETE_WINDOW");

	    int[] protocols = window.getWMProtocols();
	    if ((protocols == null) || (protocols.length == 0)) {
		int[] newArray = { xa_WM_DELETE_WINDOW };
		protocols = newArray;
	    } else {
		int oldNum = protocols.length;
		int[] newArray = new int[oldNum+1];
		System.arraycopy(protocols, 0, newArray, 0, oldNum);
		newArray[oldNum] = xa_WM_DELETE_WINDOW;
		protocols = newArray;
	    }
	    window.setWMProtocols(protocols);
	}
	
	
    }
    public void removeWindowCloseRequestListener(WindowCloseRequestListener
						 wcrl) {
	windowCloseRequestListeners.removeElement(wcrl);
	// FIXME: Remove WM_PROTOCOLS when the time is right

    }
    void fireWindowCloseRequestEvent(ClientMessageEvent message) {

	
	int size = windowCloseRequestListeners.size();
	if (size == 0) return;

	WindowCloseRequestEvent wcre =
	    new WindowCloseRequestEvent(this, message);

	WindowCloseRequestListener[] listeners = new
	    WindowCloseRequestListener[size];
	windowCloseRequestListeners.copyInto(listeners);
	for (int i=0; i<size; i++) {
	    listeners[i].windowCloseRequested(wcre);
	}
    }
}
