
package java.awt;
import java.awt.peer.*;
//import java.util.Set;
//import java.util.TreeSet;


/* Most commented out code is due to lacking implementation in other
   classes. */
public class Frame extends Window 

    // "getFont()" is missing in Component
    //implements MenuContainer 
{

    public static final int NORMAL = 0;
    public static final int ICONIFIED = 1;


    private String title;
    private Image iconImage;
    private MenuBar menuBar;
    private boolean isResizable = true;
    private int state = NORMAL;
    //private static Set frames = new TreeSet();
    


    public Frame() {
	//frames.add(this);
	
    }


    //public Frame(GraphicsConfiguration gc);

    public Frame(String title) {
	this();
	setTitle(title);
    }

    //public Frame(String title, GraphicsConfiguration gc);

    protected void finalize() throws Throwable {
	//frames.remove(this);
	/* Damn... This won't work. Finalize will never be called if
	   frames has a reference to the object. We need weak
	   references to implement this correctly. */
	super.finalize();
    }

    
    public void addNotify() {
	if (peer == null) {

	    /* Use synchronization here and in peer() so that
	       painting, etc., triggered by the creation of the peer
	       is delayed until the peer is properly installed. It is
	       not OK to simply ignore paint events when peer==null,
	       since we cannot be sure that another paint event is
	       forthcoming. */
	    synchronized (this) {
		// why cast?
		setPeer((ComponentPeer) getToolkit().createFrame(this));
	    }
	}
	super.addNotify();
    }

    private final FramePeer peer() {
	synchronized (this) {
	    return (FramePeer) peer;
	}
    }




    public String getTitle() {
	return (title != null) ? title : "";
    }
    
    public void setTitle(String title) {
	this.title = title;
	if (peer != null) peer().setTitle(getTitle());
    }

    public Image getIconImage() {
	return iconImage;
    }

    public void setIconImage(Image image) {
	iconImage = image;
	//if (peer != null) peer().setIconImage(iconImage);
    }

    public MenuBar getMenuBar() {
	return menuBar;
    }

    public void setMenuBar(MenuBar mb) {
	if (menuBar != mb) {
	    //menuBar.removeNotify();
	    menuBar = mb;
	    //menuBar.addNotify();
	}	
	//if (peer != null) peer().setMenuBar(menuBar);
    }

    public boolean isResizable() {
	return isResizable;
    }

    public void setResizable(boolean resizable) {
	isResizable = resizable;
	//if (peer != null) peer().setResizable(isResizable);
    }

    public void setState(int state) {
	this.state = state;
	//if (peer != null) peer().setState(state);
    }
    

    public int getState() {
	/* State might have changed in the peer... Must check. */
	//if (peer =! null) return peer().getState(state);

	return state;
    }
    

    public void remove(MenuComponent m) {
	if (m == menuBar) {
	    setMenuBar(null);
	    return;
	}
	
	//super.remove(m);
    }
    

    public void removeNotify() {
	//if ((peer != null) && (menuBar != null)) menuBar.removeNotify();
	super.removeNotify();
    }
    
    /*
    protected String paramString() {
	return super.paramString() + ",title=" + getTitle();
    }
    */

    public static Frame[] getFrames() {
	//Frame[] array = new Frames[frames.size()];
	//return frames.toArray(array);
	//return array;

	// see finalize() comment
	String msg = "can't be implemented without weak references";
	throw new UnsupportedOperationException(msg);
    }
    
    /*
    public AccessibleContext getAccessibleContext()
    }
    */
}
